import { h } from 'preact';
import { Consumer } from './Consumer';

/** @jsx h */

export function connect(map, options = {}) {
  return function connectComponent(Component) {
    const render = mappedProps => h(Component, mappedProps);
    const Connected = props => h(Consumer, {
      map: map,
      sync: options.sync,
      observe: options.observe,
      originalProps: props,
      render: render
    });
    return Connected;
  };
}